Unit AEE2R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAE10_p;

procedure AEE2R(N :Integer; var A :Array of Real;
                var EV :Array of Real; var RAB1 :Array of Real;
                var IERR :Integer);

implementation

procedure AEE2R(N :Integer; var A :Array of Real;
                var EV :Array of Real; var RAB1 :Array of Real;
                var IERR :Integer);
var
I,B,C,D,E,F,G :Integer;
H,J,K,L,M,O,P :Real;
const
SYS051 :Real = 1.192093E-07;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15;
begin
for I:=1 to N do
 begin
  EV[I-1] := A[(I-1)+1*N];
  RAB1[I-1] := A[(I-1)+0*N];
_1:
 end;
IERR := 0;
if ( N = 1 ) 
 then goto _15;
for B:=2 to N do
 begin
_2:
  RAB1[B-2] := RAB1[B-1];
 end;
RAB1[N-1] := 0.0;
for D:=1 to N do
 begin
  C := 0;
_3:
  for E:=D to N do
   begin
    if ( E = N ) 
     then goto _5;
    if ( Abs(RAB1[E-1]) <= SYS051*(Abs(EV[E-1])+Abs(EV[E+0])) )
     then goto _5;
_4:
   end;
_5:
  M := EV[D-1];
  if ( E = D ) 
   then goto _9;
  if ( C = 30 ) 
   then goto _14;
  C := C+1;
  L := (EV[D+0]-M)/(2.0*RAB1[D-1]);
  if ( Abs(L) > 1.0 ) 
   then O := Abs(L)*Sqrt(1.0+IntPower(1.0/L,2));
  if ( Abs(L) <= 1.0 ) 
   then O := Sqrt(L*L+1.0);
  L := EV[E-1]-M+RAB1[D-1]/(L+Sign(O,L));
  P := 1.0;
  J := 1.0;
  M := 0.0;
  G := E-D;
  for F:=1 to G do
   begin
    B := E-F;
    K := P*RAB1[B-1];
    H := J*RAB1[B-1];
    if ( Abs(K) < Abs(L) ) 
     then goto _6;
    J := L/K;
    O := Sqrt(J*J+1.0);
    RAB1[B+0] := K*O;
    P := 1.0/O;
    J := J*P;
    goto _7;
_6:
    P := K/L;
    O := Sqrt(P*P+1.0);
    RAB1[B+0] := L*O;
    J := 1.0/O;
    P := P*J;
_7:
    L := EV[B+0]-M;
    O := (EV[B-1]-L)*P+2.0*J*H;
    M := P*O;
    EV[B+0] := L+M;
    L := J*O-H;
_8:
   end;
  EV[D-1] := EV[D-1]-M;
  RAB1[D-1] := L;
  RAB1[E-1] := 0.0;
  goto _3;
_9:
  if ( D = 1 ) 
   then goto _11;
  for F:=2 to D do
   begin
    B := D+2-F;
    if ( M >= EV[B-2] ) 
     then goto _12;
    EV[B-1] := EV[B-2];
_10:
   end;
_11:
  B := 1;
_12:
  EV[B-1] := M;
_13:
 end;
goto _15;
_14:
IERR := D;
_15:
if ( IERR <> 0 ) 
 then UTAE10(IERR,N,34);
end;

end.
