Unit AES1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AEE2R_p, AV04R1_p;

procedure AES1R(N :Integer; var M0 :Integer; M1 :Integer;
                MH :Integer; M2 :Integer; var EPS0 :Real; FF :Proc_F4A;
                var VJ :Array of Real; var W :Array of Real;
                var B :Array of Real; var A :Array of Real;
                var NAC :Integer; var TETA :Array of Real;
                var TETA1 :Array of Real; var IR :Array of Integer;
                var IP :Integer);

implementation

procedure AES1R(N :Integer; var M0 :Integer; M1 :Integer;
                MH :Integer; M2 :Integer; var EPS0 :Real; FF :Proc_F4A;
                var VJ :Array of Real; var W :Array of Real;
                var B :Array of Real; var A :Array of Real;
                var NAC :Integer; var TETA :Array of Real;
                var TETA1 :Array of Real; var IR :Array of Integer;
                var IP :Integer);
var
I,I1,ID2,IERR,IMAX,IMAX0,J,J1,J2,L,MET,MI,MI1,NAC1 :Integer;
A1,ALFA,B1,B2,BETA,D1,D2,DL,EPS,F,R,S,S1,T,T1 :Real;
const
SYS051 :Real = 1.192093E-07;
SYS020 :Real = 0.69314718055994530941723212145817;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,
_300,_310,_320,_330;
begin
if ( M0 <>  0 ) 
 then goto _40;
R := Sqrt(AV04R1(VJ,VJ,N));
if ( R <>  0 ) 
 then goto _20;
for I:=1 to N do
 begin
  VJ[I-1] := 1.0;
_10:
 end;
R := Sqrt((N));
_20:
F := 1.0/R;
for I:=1 to N do
 begin
  VJ[I-1] := VJ[I-1]*F;
  W[I-1] := 0.0;
_30:
 end;
_40:
B[0] := 0.0;
MI := M0 + 1;
BETA := B[MI-1];
NAC := 0;
IP := 0;
MI1 := M1;
while ( MI1<=M2 ) do
 begin
  NAC1 := NAC;
  for J:=MI to MI1 do
   begin
    FF(VJ,W,N,0.0);
    ALFA := AV04R1(W,VJ,N);
    B[J-1] := BETA;
    A[J-1] := ALFA;
    for I:=1 to N do
     begin
      W[I-1] := W[I-1] - ALFA*VJ[I-1];
_50:
     end;
    BETA := Sqrt(AV04R1(W,W,N));
    F := EMax1(EMax1(Abs(ALFA),BETA),F);
    EPS := F*SYS051;
    if ( BETA <=  EPS ) 
     then goto _80;
    S := 1.0/BETA;
    for I:=1 to N do
     begin
      R := VJ[I-1];
      VJ[I-1] := W[I-1]*S;
      W[I-1] := R*BETA;
_60:
     end;
_70:
   end;
  J := MI1;
_80:
  J1 := J + 1;
  J2 := 2*J;
  for I:=1 to J do
   begin
    I1 := I + J;
    B[I1-1] := A[I-1];
_90:
   end;
  AEE2R(J,B,TETA,A,IERR);
  if ( IERR <>  0 ) 
   then goto _330;
  F := EMax1(Abs(TETA[0]),Abs(TETA[J-1]));
  R := 10.0*J*SYS051;
  EPS0 := EMax1(EPS0,R);
  EPS := R*F;
  IMAX := Trunc( Ln(EPS)/SYS020 - 1 );
  IMAX0 := Trunc( Ln(EPS0*F)/SYS020 - 1 );
  A1 := B[J+0];
  for I:=J1 to J2 do
   begin
    B[I-1] := B[I+0];
_100:
   end;
  B2 := B[1];
  B[1] := 0.0;
  J1 := J - 1;
  AEE2R(J1,B[1],TETA1,A,IERR);
  if ( IERR <>  0 ) 
   then goto _330;
  T1 := TETA[0];
  IR[0] := 0;
  S1 := TETA1[0];
  if ( Abs(T1-S1) <=  EPS ) 
   then IR[0] := 3;
  for I:=2 to J do
   begin
    IR[I-1] := 0;
    T := TETA[I-1];
    if ( I <>  J ) 
     then S := TETA1[I-1];
    if ( Abs(T-T1) <=  EPS ) 
     then goto _110;
    R := EMin1(Abs(T-S1),Abs(T-S));
    if ( R >  EPS ) 
     then goto _120;
    IR[I-1] := 3;
    goto _120;
_110:
    if ( IR[I-2] <>  2 ) 
     then IR[I-2] := 1;
    IR[I-1] := 2;
_120:
    T1 := T;
    S1 := S;
_130:
   end;
  NAC := J;
  for I:=1 to J do
   begin
    if ( IR[I-1] >=  2 ) 
     then NAC := NAC - 1;
_140:
   end;
  B[1] := B2;
  if ( NAC =  NAC1 ) or (  NAC =  N ) or (  BETA <=  EPS )
   then goto _180;
_150:
  for I:=1 to J do
   begin
    I1 := I + J1;
    A[I-1] := B[I1-1];
_160:
   end;
  A[0] := A1;
  MI := MI1 + 1;
_170:
  inc(MI1,MH);
 end;
MI1 := M2;
_180:
L := 4;
S := IntPower(2.0,L);
DL := 1.0/S;
D1 := BETA;
D2 := 0.0;
MET := 210;
for I:=2 to J do
 begin
  D1 := D1*B[I-1];
  if ( D1 =  0.0 ) 
   then goto _220;
_190:
  if ( Abs(D1) <  1 ) 
   then goto _200;
  D1 := D1*DL;
  D2 := D2 + L;
  goto _190;
_200:
  if ( Abs(D1) >=  DL ) 
   then begin
         if ( MET=210 ) then goto _210 else
         if ( MET=230 ) then goto _230 else
         if ( MET=240 ) then goto _240 else
         if ( MET=260 ) then goto _260;
        end;
  D1 := D1*S;
  D2 := D2 - L;
  goto _200;
_210:
 end;
_220:
B1 := D1;
B2 := D2;
for I:=1 to J do
 begin
  A[I-1] := 2.0;
  if ( IR[I-1] =  1 ) 
   then A[I-1] := 10.0;
  if ( IR[I-1] <>  0 ) 
   then goto _290;
  if ( B1 =  0.0 ) 
   then goto _280;
  D1 := 1.0;
  D2 := 0.0;
  MET := 230;
  T := TETA[I-1];
  for J2:=1 to J do
   begin
    if ( J2 =  I ) 
     then goto _230;
    D1 := D1*(TETA[J2-1] - T);
    goto _190;
_230:
   end;
  J1 := J - 1;
  MET := 240;
  for J2:=1 to J1 do
   begin
    D1 := D1*(TETA1[J2-1] - T);
    goto _190;
_240:
   end;
  D1 := B1/Sqrt(Abs(D1));
  D2 := B2 - D2*0.5;
  ID2 := Trunc( D2 );
  if ( ID2 =  D2 ) 
   then goto _250;
  D2 := D2 - 0.5;
  D1 := D1*Sqrt(2.0);
_250:
  L := 1;
  S := 2.0;
  DL := 0.5;
  MET := 260;
  goto _190;
_260:
  ID2 := Trunc( D2 );
  if ( ID2 <=  IMAX0 ) 
   then goto _270;
  if ( J <  M2 ) 
   then goto _150;
  IP := 2;
_270:
  if ( ID2 <=  IMAX ) 
   then goto _280;
  A[I-1] := D1;
  IR[I-1] := ID2;
  goto _290;
_280:
  A[I-1] := 1.0;
  IR[I-1] := IMAX;
_290:
 end;
I1 := 0;
for I:=1 to J do
 begin
  if ( A[I-1] =  2.0 ) 
   then goto _310;
  I1 := I1 + 1;
  TETA[I1-1] := TETA[I-1];
  if ( A[I-1] <>  10.0 ) 
   then goto _300;
  TETA1[I1-1] := 1.0;
  IR[I1-1] := IMAX;
  goto _310;
_300:
  IR[I1-1] := IR[I-1];
  TETA1[I1-1] := A[I-1];
_310:
 end;
for I:=1 to J do
 begin
  I1 := I + J1;
  A[I-1] := B[I1-1];
_320:
 end;
A[0] := A1;
B[J+0] := BETA;
M0 := J;
if ( BETA <=  EPS ) 
 then IP := 3;
if ( NAC =  N ) 
 then IP := 0;
if ( NAC <  N ) 
 then IP := 1;
_330:
if ( IERR <>  0 ) 
 then IP := -1;
end;

end.
